diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/mesh/model/dot11s/ie-dot11s-id.cc ns-3.39/src/mesh/model/dot11s/ie-dot11s-id.cc
--- ns-3.38/src/mesh/model/dot11s/ie-dot11s-id.cc	2023-03-16 20:54:23.788869100 -0700
+++ ns-3.39/src/mesh/model/dot11s/ie-dot11s-id.cc	2023-07-05 14:23:48.033428200 -0700
@@ -67,21 +67,13 @@
     {
         i++;
     }
-    if (m_meshId[i] != o.m_meshId[i])
-    {
-        return false;
-    }
-    return true;
+    return m_meshId[i] == o.m_meshId[i];
 }
 
 bool
 IeMeshId::IsBroadcast() const
 {
-    if (m_meshId[0] == 0)
-    {
-        return true;
-    }
-    return false;
+    return m_meshId[0] == 0;
 }
 
 char*
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/mesh/model/dot11s/peer-link-frame.cc ns-3.39/src/mesh/model/dot11s/peer-link-frame.cc
--- ns-3.38/src/mesh/model/dot11s/peer-link-frame.cc	2023-03-16 20:54:23.788869100 -0700
+++ ns-3.39/src/mesh/model/dot11s/peer-link-frame.cc	2023-07-05 14:23:48.033428200 -0700
@@ -34,6 +34,7 @@
 PeerLinkOpenStart::PeerLinkOpenStart()
     : m_capability(0),
       m_rates(SupportedRates()),
+      m_extendedRates(ExtendedSupportedRatesIE()),
       m_meshId(),
       m_config(IeConfiguration())
 {
@@ -44,6 +45,7 @@
 {
     m_capability = fields.capability;
     m_rates = fields.rates;
+    m_extendedRates = fields.extendedRates;
     m_meshId = fields.meshId;
     m_config = fields.config;
 }
@@ -55,6 +57,7 @@
     /// \todo protocol version:
     retval.capability = m_capability;
     retval.rates = m_rates;
+    retval.extendedRates = m_extendedRates;
     retval.meshId = m_meshId;
     retval.config = m_config;
 
@@ -93,9 +96,9 @@
     uint32_t size = 0; // Peering protocol
     size += 2;         // capability
     size += m_rates.GetSerializedSize();
-    if (m_rates.GetNRates() > 8)
+    if (m_extendedRates)
     {
-        size += m_rates.extended->GetSerializedSize();
+        size += m_extendedRates->GetSerializedSize();
     }
     size += m_meshId.GetInformationFieldSize() + 2;
     size += m_config.GetInformationFieldSize() + 2;
@@ -109,9 +112,9 @@
 
     i.WriteHtolsbU16(m_capability);
     i = m_rates.Serialize(i);
-    if (m_rates.GetNRates() > 8)
+    if (m_extendedRates)
     {
-        i = m_rates.extended->Serialize(i);
+        i = m_extendedRates->Serialize(i);
     }
     i = m_meshId.Serialize(i);
     i = m_config.Serialize(i);
@@ -124,7 +127,13 @@
 
     m_capability = i.ReadLsbtohU16();
     i = m_rates.Deserialize(i);
-    i = WifiInformationElement::DeserializeIfPresent(m_rates.extended, i);
+    m_extendedRates.emplace();
+    auto tmp = m_extendedRates->DeserializeIfPresent(i);
+    if (tmp.GetDistanceFrom(i) == 0)
+    {
+        m_extendedRates.reset();
+    }
+    i = tmp;
     uint8_t id = i.ReadU8();
     uint8_t length = i.ReadU8();
     m_meshId.DeserializeInformationField(i, length);
@@ -300,9 +309,9 @@
     size += 2;         // capability
     size += 2;         // AID of remote peer
     size += m_rates.GetSerializedSize();
-    if (m_rates.GetNRates() > 8)
+    if (m_extendedRates)
     {
-        size += m_rates.extended->GetSerializedSize();
+        size += m_extendedRates->GetSerializedSize();
     }
     size += m_config.GetInformationFieldSize() + 2;
     return size;
@@ -316,9 +325,9 @@
     i.WriteHtolsbU16(m_capability);
     i.WriteHtolsbU16(m_aid);
     i = m_rates.Serialize(i);
-    if (m_rates.GetNRates() > 8)
+    if (m_extendedRates)
     {
-        i = m_rates.extended->Serialize(i);
+        i = m_extendedRates->Serialize(i);
     }
     i = m_config.Serialize(i);
 }
@@ -331,7 +340,13 @@
     m_capability = i.ReadLsbtohU16();
     m_aid = i.ReadLsbtohU16();
     i = m_rates.Deserialize(i);
-    i = WifiInformationElement::DeserializeIfPresent(m_rates.extended, i);
+    m_extendedRates.emplace();
+    auto tmp = m_extendedRates->DeserializeIfPresent(i);
+    if (tmp.GetDistanceFrom(i) == 0)
+    {
+        m_extendedRates.reset();
+    }
+    i = tmp;
     uint8_t id = i.ReadU8();
     uint8_t length = i.ReadU8();
     m_config.DeserializeInformationField(i, length);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/mesh/model/dot11s/peer-link-frame.h ns-3.39/src/mesh/model/dot11s/peer-link-frame.h
--- ns-3.38/src/mesh/model/dot11s/peer-link-frame.h	2023-03-16 20:54:23.788869100 -0700
+++ ns-3.39/src/mesh/model/dot11s/peer-link-frame.h	2023-07-05 14:23:48.033428200 -0700
@@ -27,6 +27,8 @@
 #include "ns3/header.h"
 #include "ns3/supported-rates.h"
 
+#include <optional>
+
 namespace ns3
 {
 namespace dot11s
@@ -57,8 +59,9 @@
         IePeeringProtocol protocol; ///< Peering protocol version - 3 octets
         uint16_t capability;        ///< open and confirm
         SupportedRates rates;       ///< open and confirm
-        IeMeshId meshId;            ///< open and close
-        IeConfiguration config;     ///< open and confirm
+        std::optional<ExtendedSupportedRatesIE> extendedRates; ///< open and confirm
+        IeMeshId meshId;                                       ///< open and close
+        IeConfiguration config;                                ///< open and confirm
     };
 
     /**
@@ -85,10 +88,11 @@
     uint32_t Deserialize(Buffer::Iterator start) override;
 
   private:
-    uint16_t m_capability;    ///< capability
-    SupportedRates m_rates;   ///< rates
-    IeMeshId m_meshId;        ///< mesh ID
-    IeConfiguration m_config; ///< config
+    uint16_t m_capability;                                   ///< capability
+    SupportedRates m_rates;                                  ///< rates
+    std::optional<ExtendedSupportedRatesIE> m_extendedRates; ///< extended rates
+    IeMeshId m_meshId;                                       ///< mesh ID
+    IeConfiguration m_config;                                ///< config
 
     /**
      * equality operator
@@ -190,7 +194,8 @@
         uint16_t capability;        ///< open and confirm
         uint16_t aid;               ///< confirm only
         SupportedRates rates;       ///< open and confirm
-        IeConfiguration config;     ///< open and confirm
+        std::optional<ExtendedSupportedRatesIE> extendedRates; ///< open and confirm
+        IeConfiguration config;                                ///< open and confirm
     };
 
     /**
@@ -217,10 +222,11 @@
     uint32_t Deserialize(Buffer::Iterator start) override;
 
   private:
-    uint16_t m_capability;    ///< capability
-    uint16_t m_aid;           ///< aid
-    SupportedRates m_rates;   ///< rates
-    IeConfiguration m_config; ///< config
+    uint16_t m_capability;                                   ///< capability
+    uint16_t m_aid;                                          ///< aid
+    SupportedRates m_rates;                                  ///< rates
+    std::optional<ExtendedSupportedRatesIE> m_extendedRates; ///< extended rates
+    IeConfiguration m_config;                                ///< config
 
     /**
      * equality operator
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/mesh/model/dot11s/peer-management-protocol.h ns-3.39/src/mesh/model/dot11s/peer-management-protocol.h
--- ns-3.38/src/mesh/model/dot11s/peer-management-protocol.h	2023-03-16 20:54:23.788869100 -0700
+++ ns-3.39/src/mesh/model/dot11s/peer-management-protocol.h	2023-07-05 14:23:48.037428100 -0700
@@ -300,13 +300,13 @@
      * \brief Indicates changes in peer links
      * \param interface the interface
      * \param peerAddress the peer address
-     * \param peerMeshPointAddres the peer mesh point address
+     * \param peerMeshPointAddress the peer mesh point address
      * \param ostate old state
      * \param nstate new state
      */
     void PeerLinkStatus(uint32_t interface,
                         Mac48Address peerAddress,
-                        Mac48Address peerMeshPointAddres,
+                        Mac48Address peerMeshPointAddress,
                         PeerLink::PeerState ostate,
                         PeerLink::PeerState nstate);
     /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/mesh/model/dot11s/peer-management-protocol-mac.cc ns-3.39/src/mesh/model/dot11s/peer-management-protocol-mac.cc
--- ns-3.38/src/mesh/model/dot11s/peer-management-protocol-mac.cc	2023-03-16 20:54:23.788869100 -0700
+++ ns-3.39/src/mesh/model/dot11s/peer-management-protocol-mac.cc	2023-07-05 14:23:48.037428100 -0700
@@ -139,7 +139,8 @@
                 m_stats.brokenMgt++;
                 return false;
             }
-            if (!(m_parent->CheckSupportedRates(fields.rates)))
+            if (!(m_parent->CheckSupportedRates(
+                    AllSupportedRates{fields.rates, fields.extendedRates})))
             {
                 NS_LOG_DEBUG("PEER_LINK_OPEN:  configuration mismatch");
                 m_protocol->ConfigurationMismatch(m_ifIndex, peerAddress);
@@ -156,7 +157,8 @@
             PeerLinkConfirmStart peerFrame;
             packet->RemoveHeader(peerFrame);
             fields = peerFrame.GetFields();
-            if (!(m_parent->CheckSupportedRates(fields.rates)))
+            if (!(m_parent->CheckSupportedRates(
+                    AllSupportedRates{fields.rates, fields.extendedRates})))
             {
                 NS_LOG_DEBUG("PEER_LINK_CONFIRM:  configuration mismatch");
                 m_protocol->ConfigurationMismatch(m_ifIndex, peerAddress);
@@ -290,7 +292,9 @@
     if (peerElement.SubtypeIsOpen())
     {
         PeerLinkOpenStart::PlinkOpenStartFields fields;
-        fields.rates = m_parent->GetSupportedRates();
+        auto allSupportedRates = m_parent->GetSupportedRates();
+        fields.rates = allSupportedRates.rates;
+        fields.extendedRates = allSupportedRates.extendedRates;
         fields.capability = 0;
         fields.meshId = *(m_protocol->GetMeshId());
         fields.config = meshConfig;
@@ -307,7 +311,9 @@
     if (peerElement.SubtypeIsConfirm())
     {
         PeerLinkConfirmStart::PlinkConfirmStartFields fields;
-        fields.rates = m_parent->GetSupportedRates();
+        auto allSupportedRates = m_parent->GetSupportedRates();
+        fields.rates = allSupportedRates.rates;
+        fields.extendedRates = allSupportedRates.extendedRates;
         fields.capability = 0;
         fields.config = meshConfig;
         PeerLinkConfirmStart plinkConfirm;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/mesh/model/dot11s/peer-management-protocol-mac.h ns-3.39/src/mesh/model/dot11s/peer-management-protocol-mac.h
--- ns-3.38/src/mesh/model/dot11s/peer-management-protocol-mac.h	2023-03-16 20:54:23.788869100 -0700
+++ ns-3.39/src/mesh/model/dot11s/peer-management-protocol-mac.h	2023-07-05 14:23:48.037428100 -0700
@@ -186,7 +186,7 @@
      * Set peer manager protocol function
      * \param protocol the peer manager protocol
      */
-    void SetPeerManagerProtcol(Ptr<PeerManagementProtocol> protocol);
+    void SetPeerManagerProtocol(Ptr<PeerManagementProtocol> protocol);
     /**
      * Send peer link management frame function
      * \param peerAddress the peer MAC address
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/mesh/model/mesh-information-element-vector.cc ns-3.39/src/mesh/model/mesh-information-element-vector.cc
--- ns-3.38/src/mesh/model/mesh-information-element-vector.cc	2023-03-16 20:54:23.788869100 -0700
+++ ns-3.39/src/mesh/model/mesh-information-element-vector.cc	2023-07-05 14:23:48.037428100 -0700
@@ -41,18 +41,24 @@
 NS_OBJECT_ENSURE_REGISTERED(MeshInformationElementVector);
 
 MeshInformationElementVector::MeshInformationElementVector()
+    : m_maxSize(1500)
 {
 }
 
 MeshInformationElementVector::~MeshInformationElementVector()
 {
+    for (IE_VECTOR::iterator i = m_elements.begin(); i != m_elements.end(); i++)
+    {
+        *i = nullptr;
+    }
+    m_elements.clear();
 }
 
 TypeId
 MeshInformationElementVector::GetTypeId()
 {
     static TypeId tid = TypeId("ns3::MeshInformationElementVector")
-                            .SetParent<WifiInformationElementVector>()
+                            .SetParent<Header>()
                             .SetGroupName("Mesh")
                             .AddConstructor<MeshInformationElementVector>();
     return tid;
@@ -65,6 +71,44 @@
 }
 
 uint32_t
+MeshInformationElementVector::GetSerializedSize() const
+{
+    return GetSize();
+}
+
+void
+MeshInformationElementVector::Serialize(Buffer::Iterator start) const
+{
+    for (IE_VECTOR::const_iterator i = m_elements.begin(); i != m_elements.end(); i++)
+    {
+        start = (*i)->Serialize(start);
+    }
+}
+
+uint32_t
+MeshInformationElementVector::Deserialize(Buffer::Iterator start)
+{
+    NS_FATAL_ERROR("This variant should not be called on a variable-sized header");
+    return 0;
+}
+
+uint32_t
+MeshInformationElementVector::Deserialize(Buffer::Iterator start, Buffer::Iterator end)
+{
+    uint32_t size = start.GetDistanceFrom(end);
+    uint32_t remaining = size;
+    while (remaining > 0)
+    {
+        uint32_t deserialized = DeserializeSingleIe(start);
+        start.Next(deserialized);
+        NS_ASSERT(deserialized <= remaining);
+        remaining -= deserialized;
+    }
+    NS_ASSERT_MSG(remaining == 0, "Error in deserialization");
+    return size;
+}
+
+uint32_t
 MeshInformationElementVector::DeserializeSingleIe(Buffer::Iterator start)
 {
     Buffer::Iterator i = start;
@@ -105,7 +149,8 @@
         newElement = Create<dot11s::IePeeringProtocol>();
         break;
     default:
-        return WifiInformationElementVector::DeserializeSingleIe(i);
+        NS_FATAL_ERROR("Information element " << +id << " is not implemented");
+        return 0;
     }
     if (GetSize() + length > m_maxSize)
     {
@@ -116,4 +161,91 @@
     return i.GetDistanceFrom(start);
 }
 
+void
+MeshInformationElementVector::Print(std::ostream& os) const
+{
+    for (IE_VECTOR::const_iterator i = m_elements.begin(); i != m_elements.end(); i++)
+    {
+        os << "(";
+        (*i)->Print(os);
+        os << ")";
+    }
+}
+
+MeshInformationElementVector::Iterator
+MeshInformationElementVector::Begin()
+{
+    return m_elements.begin();
+}
+
+MeshInformationElementVector::Iterator
+MeshInformationElementVector::End()
+{
+    return m_elements.end();
+}
+
+bool
+MeshInformationElementVector::AddInformationElement(Ptr<WifiInformationElement> element)
+{
+    if (element->GetSerializedSize() + GetSize() > m_maxSize)
+    {
+        return false;
+    }
+    m_elements.push_back(element);
+    return true;
+}
+
+Ptr<WifiInformationElement>
+MeshInformationElementVector::FindFirst(WifiInformationElementId id) const
+{
+    for (IE_VECTOR::const_iterator i = m_elements.begin(); i != m_elements.end(); i++)
+    {
+        if ((*i)->ElementId() == id)
+        {
+            return (*i);
+        }
+    }
+    return nullptr;
+}
+
+uint32_t
+MeshInformationElementVector::GetSize() const
+{
+    uint32_t size = 0;
+    for (IE_VECTOR::const_iterator i = m_elements.begin(); i != m_elements.end(); i++)
+    {
+        size += (*i)->GetSerializedSize();
+    }
+    return size;
+}
+
+bool
+MeshInformationElementVector::operator==(const MeshInformationElementVector& a) const
+{
+    if (m_elements.size() != a.m_elements.size())
+    {
+        NS_ASSERT(false);
+        return false;
+    }
+    // In principle we could bypass some of the faffing about (and speed
+    // the comparison) by simply serialising each IE vector into a
+    // buffer and memcmp'ing the two.
+    //
+    // I'm leaving it like this, however, so that there is the option of
+    // having individual Information Elements implement slightly more
+    // flexible equality operators.
+    MeshInformationElementVector::IE_VECTOR::const_iterator j = a.m_elements.begin();
+    for (MeshInformationElementVector::IE_VECTOR::const_iterator i = m_elements.begin();
+         i != m_elements.end();
+         i++, j++)
+    {
+        if (!(*(*i) == *(*j)))
+        {
+            return false;
+        }
+    }
+
+    return true;
+}
+
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/mesh/model/mesh-information-element-vector.h ns-3.39/src/mesh/model/mesh-information-element-vector.h
--- ns-3.38/src/mesh/model/mesh-information-element-vector.h	2023-03-16 20:54:23.788869100 -0700
+++ ns-3.39/src/mesh/model/mesh-information-element-vector.h	2023-07-05 14:23:48.037428100 -0700
@@ -21,7 +21,7 @@
 #ifndef MESH_INFORMATION_ELEMENT_VECTOR_H
 #define MESH_INFORMATION_ELEMENT_VECTOR_H
 
-#include "ns3/wifi-information-element-vector.h"
+#include "ns3/wifi-information-element.h"
 
 namespace ns3
 {
@@ -30,7 +30,17 @@
     ((WifiInformationElementId)74) // to be removed (Protocol ID should be part of the Mesh Peering
                                    // Management IE)
 
-class MeshInformationElementVector : public WifiInformationElementVector
+/**
+ * \brief Information element vector
+ * \ingroup wifi
+ *
+ * Implements a vector of WifiInformationElements.
+ * Information elements typically come in groups, and the
+ * WifiInformationElementVector class provides a representation of a
+ * series of IEs, and the facility for serialisation to and
+ * deserialisation from the over-the-air format.
+ */
+class MeshInformationElementVector : public Header
 {
   public:
     MeshInformationElementVector();
@@ -41,8 +51,88 @@
      * \return the object TypeId
      */
     static TypeId GetTypeId();
+
     TypeId GetInstanceTypeId() const override;
-    uint32_t DeserializeSingleIe(Buffer::Iterator start) override;
+    uint32_t GetSerializedSize() const override;
+    void Serialize(Buffer::Iterator start) const override;
+    /**
+     * \attention This variant should not be used but is implemented due to
+     * backward compatibility reasons
+     *
+     * \param start buffer location to start deserializing from
+     * \return number of bytes deserialized
+     */
+    uint32_t Deserialize(Buffer::Iterator start) override;
+    /**
+     * Deserialize a number of WifiInformationElements
+     *
+     * The size of this Header should equal start.GetDistanceFrom (end).
+     *
+     * \param start starting buffer location
+     * \param end ending buffer location
+     * \return number of bytes deserialized
+     */
+    uint32_t Deserialize(Buffer::Iterator start, Buffer::Iterator end) override;
+    void Print(std::ostream& os) const override;
+
+    /**
+     * \brief Needed when you try to deserialize a lonely IE inside other header
+     *
+     * \param start is the start of the buffer
+     *
+     * \return deserialized bytes
+     */
+    uint32_t DeserializeSingleIe(Buffer::Iterator start);
+
+    /// As soon as this is a vector, we define an Iterator
+    typedef std::vector<Ptr<WifiInformationElement>>::iterator Iterator;
+    /**
+     * Returns Begin of the vector
+     * \returns the begin of the vector
+     */
+    Iterator Begin();
+    /**
+     * Returns End of the vector
+     * \returns the end of the vector
+     */
+    Iterator End();
+    /**
+     * add an IE, if maxSize has exceeded, returns false
+     *
+     * \param element wifi information element to add
+     * \returns true is added
+     */
+    bool AddInformationElement(Ptr<WifiInformationElement> element);
+    /**
+     * vector of pointers to information elements is the body of IeVector
+     *
+     * \param id the element id to find
+     * \returns the information element
+     */
+    Ptr<WifiInformationElement> FindFirst(WifiInformationElementId id) const;
+
+    /**
+     * Check if the given WifiInformationElementVectors are equivalent.
+     *
+     * \param a another WifiInformationElementVector
+     *
+     * \return true if the given WifiInformationElementVectors are equivalent,
+     *         false otherwise
+     */
+    virtual bool operator==(const MeshInformationElementVector& a) const;
+
+  protected:
+    /**
+     * typedef for a vector of WifiInformationElements.
+     */
+    typedef std::vector<Ptr<WifiInformationElement>> IE_VECTOR;
+    /**
+     * Current number of bytes
+     * \returns the number of bytes
+     */
+    uint32_t GetSize() const;
+    IE_VECTOR m_elements; //!< Information element vector
+    uint16_t m_maxSize;   //!< Size in bytes (actually, max packet length)
 };
 
 } // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/mesh/model/mesh-point-device.cc ns-3.39/src/mesh/model/mesh-point-device.cc
--- ns-3.38/src/mesh/model/mesh-point-device.cc	2023-03-16 20:54:23.788869100 -0700
+++ ns-3.39/src/mesh/model/mesh-point-device.cc	2023-07-05 14:23:48.037428100 -0700
@@ -189,7 +189,7 @@
                                                   packet,
                                                   protocol,
                                                   MakeCallback(&MeshPointDevice::DoSend, this));
-    if (result == false)
+    if (!result)
     {
         NS_LOG_DEBUG("Request to forward packet " << packet << " to destination " << dst
                                                   << " failed; dropping packet");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/mesh/model/mesh-wifi-beacon.cc ns-3.39/src/mesh/model/mesh-wifi-beacon.cc
--- ns-3.38/src/mesh/model/mesh-wifi-beacon.cc	2023-03-16 20:54:23.788869100 -0700
+++ ns-3.39/src/mesh/model/mesh-wifi-beacon.cc	2023-07-05 14:23:48.037428100 -0700
@@ -25,10 +25,11 @@
 namespace ns3
 {
 
-MeshWifiBeacon::MeshWifiBeacon(Ssid ssid, SupportedRates rates, uint64_t us)
+MeshWifiBeacon::MeshWifiBeacon(Ssid ssid, AllSupportedRates rates, uint64_t us)
 {
-    m_header.SetSsid(ssid);
-    m_header.SetSupportedRates(rates);
+    m_header.Get<Ssid>() = ssid;
+    m_header.Get<SupportedRates>() = rates.rates;
+    m_header.Get<ExtendedSupportedRatesIE>() = rates.extendedRates;
     m_header.SetBeaconIntervalUs(us);
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/mesh/model/mesh-wifi-beacon.h ns-3.39/src/mesh/model/mesh-wifi-beacon.h
--- ns-3.38/src/mesh/model/mesh-wifi-beacon.h	2023-03-16 20:54:23.788869100 -0700
+++ ns-3.39/src/mesh/model/mesh-wifi-beacon.h	2023-07-05 14:23:48.037428100 -0700
@@ -47,7 +47,7 @@
      * \param rates is a set of supported rates
      * \param us beacon interval in microseconds
      */
-    MeshWifiBeacon(Ssid ssid, SupportedRates rates, uint64_t us);
+    MeshWifiBeacon(Ssid ssid, AllSupportedRates rates, uint64_t us);
 
     /**
      * Read standard Wifi beacon header
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/mesh/model/mesh-wifi-interface-mac.cc ns-3.39/src/mesh/model/mesh-wifi-interface-mac.cc
--- ns-3.38/src/mesh/model/mesh-wifi-interface-mac.cc	2023-03-16 20:54:23.788869100 -0700
+++ ns-3.39/src/mesh/model/mesh-wifi-interface-mac.cc	2023-07-05 14:23:48.037428100 -0700
@@ -317,12 +317,12 @@
     }
 }
 
-SupportedRates
+AllSupportedRates
 MeshWifiInterfaceMac::GetSupportedRates() const
 {
     // set the set of supported rates and make sure that we indicate
     // the Basic Rate set in this set of supported rates.
-    SupportedRates rates;
+    AllSupportedRates rates;
     for (const auto& mode : GetWifiPhy()->GetModeList())
     {
         uint16_t gi = ConvertGuardIntervalToNanoSeconds(mode, GetWifiPhy()->GetDevice());
@@ -339,7 +339,7 @@
 }
 
 bool
-MeshWifiInterfaceMac::CheckSupportedRates(SupportedRates rates) const
+MeshWifiInterfaceMac::CheckSupportedRates(AllSupportedRates rates) const
 {
     for (uint32_t i = 0; i < GetWifiRemoteStationManager()->GetNBasicModes(); i++)
     {
@@ -459,9 +459,11 @@
                                              << " microseconds");
 
         // update supported rates
-        if (beacon_hdr.GetSsid().IsEqual(GetSsid()))
+        if (beacon_hdr.Get<Ssid>()->IsEqual(GetSsid()))
         {
-            SupportedRates rates = beacon_hdr.GetSupportedRates();
+            NS_ASSERT(beacon_hdr.Get<SupportedRates>());
+            auto rates = AllSupportedRates{*beacon_hdr.Get<SupportedRates>(),
+                                           beacon_hdr.Get<ExtendedSupportedRatesIE>()};
 
             for (const auto& mode : GetWifiPhy()->GetModeList())
             {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/mesh/model/mesh-wifi-interface-mac.h ns-3.39/src/mesh/model/mesh-wifi-interface-mac.h
--- ns-3.38/src/mesh/model/mesh-wifi-interface-mac.h	2023-03-16 20:54:23.788869100 -0700
+++ ns-3.39/src/mesh/model/mesh-wifi-interface-mac.h	2023-07-05 14:23:48.037428100 -0700
@@ -163,13 +163,13 @@
      * \param rates Rates.
      * \return true if rates are supported
      */
-    bool CheckSupportedRates(SupportedRates rates) const;
+    bool CheckSupportedRates(AllSupportedRates rates) const;
 
     /**
      * Get supported rates.
      * \return list of supported bitrates
      */
-    SupportedRates GetSupportedRates() const;
+    AllSupportedRates GetSupportedRates() const;
 
     /// \name Metric Calculation routines:
     ///@{
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/mesh/test/examples-to-run.py ns-3.39/src/mesh/test/examples-to-run.py
--- ns-3.38/src/mesh/test/examples-to-run.py	2023-03-16 20:54:23.792869000 -0700
+++ ns-3.39/src/mesh/test/examples-to-run.py	2023-07-05 14:23:48.041428000 -0700
@@ -1,5 +1,4 @@
 #! /usr/bin/env python3
-## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
 
 # A list of C++ examples to run in order to ensure that they remain
 # buildable and runnable over time.  Each tuple in the list contains
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/mobility/examples/reference-point-group-mobility-example.cc ns-3.39/src/mobility/examples/reference-point-group-mobility-example.cc
--- ns-3.38/src/mobility/examples/reference-point-group-mobility-example.cc	2023-03-16 20:54:23.792869000 -0700
+++ ns-3.39/src/mobility/examples/reference-point-group-mobility-example.cc	2023-07-05 14:23:48.045428000 -0700
@@ -16,7 +16,7 @@
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  *
  * Author: Michele Polese <michele.polese@gmail.com>
- * Heavily edited by Tom Henderson (to reuse HierachicalMobilityModel)
+ * Heavily edited by Tom Henderson (to reuse HierarchicalMobilityModel)
  */
 
 /**
@@ -140,7 +140,7 @@
     waypointMm->AddWaypoint(Waypoint(Seconds(700), Vector(90, 10, 0)));
     waypointMm->AddWaypoint(Waypoint(Seconds(800), Vector(10, 10, 0)));
 
-    // Each HierachicalMobilityModel contains the above model as the Parent,
+    // Each HierarchicalMobilityModel contains the above model as the Parent,
     // and a user defined model as the Child.  Two MobilityModel objects are
     // instantiated per node (one hierarchical, and one child model), and
     // a single parent model is reused across all nodes.
@@ -150,7 +150,7 @@
     // configuration.
 
     int64_t streamIndex = 1;
-    if (useHelper == false)
+    if (!useHelper)
     {
         // Assign random variable stream numbers on the parent and each child
         streamIndex += waypointMm->AssignStreams(streamIndex);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/mobility/helper/ns2-mobility-helper.cc ns-3.39/src/mobility/helper/ns2-mobility-helper.cc
--- ns-3.38/src/mobility/helper/ns2-mobility-helper.cc	2023-03-16 20:54:23.792869000 -0700
+++ ns-3.39/src/mobility/helper/ns2-mobility-helper.cc	2023-07-05 14:23:48.045428000 -0700
@@ -622,8 +622,7 @@
     }
     else if (IsNumber(str))
     {
-        std::string s2 = str;
-        std::istringstream s(s2);
+        std::istringstream s(str);
         s >> ret;
         return true;
     }
@@ -651,15 +650,8 @@
 
     nodeId = str.substr(startNodeId + 1, endNodeId - (startNodeId + 1)); // set node id
 
-    //   is number              is integer                                       is not negative
-    if (IsNumber(nodeId) && (nodeId.find_first_of('.') == std::string::npos) && (nodeId[0] != '-'))
-    {
-        return true;
-    }
-    else
-    {
-        return false;
-    }
+    //     is number           is integer                                        is not negative
+    return IsNumber(nodeId) && nodeId.find_first_of('.') == std::string::npos && nodeId[0] != '-';
 }
 
 std::string
@@ -708,13 +700,10 @@
     {
     case 4: // line like $node_(0) set X_ 11
         return pr.svals[0];
-        break;
     case 7: // line like $ns_ at 4 "$node_(0) set X_ 28"
         return pr.svals[3];
-        break;
     case 8: // line like $ns_ at 1 "$node_(0) setdest 2 3 4"
         return pr.svals[3];
-        break;
     default:
         return "";
     }
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/mobility/model/position-allocator.cc ns-3.39/src/mobility/model/position-allocator.cc
--- ns-3.38/src/mobility/model/position-allocator.cc	2023-03-16 20:54:23.792869000 -0700
+++ ns-3.39/src/mobility/model/position-allocator.cc	2023-07-05 14:23:48.045428000 -0700
@@ -267,7 +267,7 @@
     return m_n;
 }
 
-enum GridPositionAllocator::LayoutType
+GridPositionAllocator::LayoutType
 GridPositionAllocator::GetLayoutType() const
 {
     return m_layoutType;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/mobility/test/examples-to-run.py ns-3.39/src/mobility/test/examples-to-run.py
--- ns-3.38/src/mobility/test/examples-to-run.py	2023-03-16 20:54:23.792869000 -0700
+++ ns-3.39/src/mobility/test/examples-to-run.py	2023-07-05 14:23:48.045428000 -0700
@@ -1,5 +1,4 @@
 #! /usr/bin/env python3
-## -*- Mode: python; py-indent-offset: 4; indent-tabs-mode: nil; coding: utf-8; -*-
 
 # A list of C++ examples to run in order to ensure that they remain
 # buildable and runnable over time.  Each tuple in the list contains
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/mpi/examples/mpi-test-fixtures.h ns-3.39/src/mpi/examples/mpi-test-fixtures.h
--- ns-3.38/src/mpi/examples/mpi-test-fixtures.h	2023-03-16 20:54:23.796869000 -0700
+++ ns-3.39/src/mpi/examples/mpi-test-fixtures.h	2023-07-05 14:23:48.049428200 -0700
@@ -17,6 +17,9 @@
  * Author: Steven Smith <smith84@llnl.gov>
  */
 
+#ifndef MPI_TEST_FIXTURES_H
+#define MPI_TEST_FIXTURES_H
+
 #include <iomanip>
 #include <ios>
 #include <sstream>
@@ -156,3 +159,5 @@
 };
 
 } // namespace ns3
+
+#endif // MPI_TEST_FIXTURES_H
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/mpi/examples/simple-distributed.cc ns-3.39/src/mpi/examples/simple-distributed.cc
--- ns-3.38/src/mpi/examples/simple-distributed.cc	2023-03-16 20:54:23.796869000 -0700
+++ ns-3.39/src/mpi/examples/simple-distributed.cc	2023-07-05 14:23:48.049428200 -0700
@@ -226,7 +226,7 @@
         Ipv4GlobalRoutingHelper::PopulateRoutingTables();
     }
 
-    if (tracing == true)
+    if (tracing)
     {
         if (systemId == 0)
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/mpi/examples/simple-distributed-empty-node.cc ns-3.39/src/mpi/examples/simple-distributed-empty-node.cc
--- ns-3.38/src/mpi/examples/simple-distributed-empty-node.cc	2023-03-16 20:54:23.796869000 -0700
+++ ns-3.39/src/mpi/examples/simple-distributed-empty-node.cc	2023-07-05 14:23:48.049428200 -0700
@@ -253,7 +253,7 @@
         Ipv4GlobalRoutingHelper::PopulateRoutingTables();
     }
 
-    if (tracing == true)
+    if (tracing)
     {
         if (systemId == 0)
         {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.38/src/mpi/examples/simple-distributed-mpi-comm.cc ns-3.39/src/mpi/examples/simple-distributed-mpi-comm.cc
--- ns-3.38/src/mpi/examples/simple-distributed-mpi-comm.cc	2023-03-16 20:54:23.796869000 -0700
+++ ns-3.39/src/mpi/examples/simple-distributed-mpi-comm.cc	2023-07-05 14:23:48.049428200 -0700
@@ -436,7 +436,7 @@
         Ipv4GlobalRoutingHelper::PopulateRoutingTables();
     }
 
-    if (tracing == true)
+    if (tracing)
     {
         if (systemId == 0)
         {
